<?php

class Shopware_Plugins_Frontend_rvdwCrispImage_Bootstrap extends Shopware_Components_Plugin_Bootstrap{


    public function getCapabilities(){
        return array(
            "install" => true,
            "update" => true,
            "enable" => true

        );
    }
    public function getLabel(){
            return "Crisp Image";
        }

    public function getVersion(){
            return "1.0.0";
        }
    public function getInfo(){
            return array(
                "version" => $this->getVersion(),
                "label" => $this->getLabel(),
                "supplier" => "7synth",
                "description" => "This Plugin will bring more crispness to you images. Affect all images!",
                "support" => "info@7synth.com",
                "link" => "http://7synth.com",
                "author" => "R.v.d.Waydbrink",
                "copyright" => "2017 R.v.d.Waydbrink",
                "license" => "by request"
            );
        }
    public function install(){
        $this->registerEvents();
        $this->createConfiguration();

        return true;
        /*return array(
                "success" => true,
                "invalidateCache" => array("frontend")
            );*/
        }
    public function uninstall(){
            return array(
                "success" => true,
                "invalidateCache" => array("frontend")
            );
        }
    private function registerEvents(){
            $this->subscribeEvent(
                'Theme_Compiler_Collect_Plugin_Less',
                'addLessFiles'
            );
        }

    public function createConfiguration(){
        $form = $this->Form();
        $form->setElement("checkbox","active",
            array("label"=>"Activate",
                "value"=>true,
                "description" => "Plugin active in this Shop/Subshop.",
                "scope" => Shopware\Models\Config\Element::SCOPE_SHOP
            )
        );
        $form->setElement("select","chrome",
            array("label"=>"Chrome",
                "value" => array("crisp", 'crisp'),
                'store' => array(
                    array("autoset", 'auto'),
                    array("crisp", 'crisp'),
                    array("pixelated", 'pixelated'),
                    array("unset", 'unset')
                ),
                "description" => "Make the plugin available in Google Chrome.",
                "scope" => Shopware\Models\Config\Element::SCOPE_SHOP
            )
        );
        $form->setElement("select","firefox",
            array("label"=>"Firefox",
                "value" => array("auto", 'auto'),
                'store' => array(
                    array("autoset", 'auto'),
                    array("crisp", 'crisp'),
                    array("pixelated", 'pixelated'),
                    array("unset", 'unset')
                ),
                "description" => "Make the plugin available in Firefox.",
                "scope" => Shopware\Models\Config\Element::SCOPE_SHOP
            )
        );
        $form->setElement("select","ie",
            array("label"=>"Internet Explorer",
                "value" => array("auto", 'auto'),
                'store' => array(
                    array("auto", 'auto'),
                    array("bicubic", 'bicubic'),
                    array("nearestneighbor", 'nearest-neighbor'),

                ),
                "description" => "Make the plugin available in Internet Explorer.",
                "scope" => Shopware\Models\Config\Element::SCOPE_SHOP
            )
        );
        $form->save();
    }
    /**
     *
     * @param Enlight_Event_EventArgs $args
     * @return \Doctrine\Common\Collections\ArrayCollection
     */
    public function addLessFiles(Enlight_Event_EventArgs $args)
    {
        $shop = $args->getShop();
        $config = $this->collection->getConfig($this->name,$shop);

        $less = new \Shopware\Components\Theme\LessDefinition(
        /* Configuration */
            array(
                'active' => $config->get('active'),
                'chrome' => $config->get('chrome'),
                'firefox' => $config->get('firefox'),
                'ie' => $config->get('ie')
            ),
            /* Less files to compile */
            array(__DIR__ . '/Views/responsive/frontend/_public/src/less/all.less'),
            /* Import directory */
            __DIR__
        );

        return new Doctrine\Common\Collections\ArrayCollection(array($less));
    }
}